﻿/*
 * 由SharpDevelop创建。
 * 用户： David Huang
 * 日期: 2015/9/8
 * 时间: 14:54
 */
using System;
using System.Windows.Forms;

namespace BackgroundWorkerTest
{
    /// <summary>
    /// Description of MainForm.
    /// </summary>
    public partial class MainForm : Form
    {
        public MainForm()
        {
            InitializeComponent();
            // 
            // backgroundWorker1
            // 
            this.backgroundWorker1.DoWork += this.BackgroundWorker1DoWork;
            this.backgroundWorker1.ProgressChanged += this.BackgroundWorker1ProgressChanged;
            this.backgroundWorker1.RunWorkerCompleted += this.BackgroundWorker1RunWorkerCompleted;
            this.backgroundWorker1.WorkerReportsProgress = true;
            this.backgroundWorker1.WorkerSupportsCancellation = true;
            this.buttonCancel.Enabled = false;
        }
        void ButtonCalculateClick(object sender, EventArgs e)
        {
            this.buttonCalculate.Enabled = false;
            this.textBoxResult.Text = string.Empty;
            this.buttonCancel.Enabled = true;
            this.backgroundWorker1.RunWorkerAsync(new Tuple<int,int>(Convert.ToInt32(this.textBoxX.Text), Convert.ToInt32(this.textBoxY.Text)));            
        }
        void ButtonCancelClick(object sender, EventArgs e)
        {
            this.backgroundWorker1.CancelAsync();            
        }
        void BackgroundWorker1DoWork(object sender, System.ComponentModel.DoWorkEventArgs e)
        {
            for (int i = 0; i < 10; i++) {
                System.Threading.Thread.Sleep(500);
                
                if (backgroundWorker1.CancellationPending) {
                    e.Cancel = true;
                    return;
                } else {
                    backgroundWorker1.ReportProgress(i * 10);
                }
            }
            var t = e.Argument as Tuple<int,int>;
            e.Result = t.Item1 + t.Item2;
        }
        void BackgroundWorker1ProgressChanged(object sender, System.ComponentModel.ProgressChangedEventArgs e)
        {
            this.progressBar1.Value = e.ProgressPercentage;
        }
        void BackgroundWorker1RunWorkerCompleted(object sender, System.ComponentModel.RunWorkerCompletedEventArgs e)
        {
            this.textBoxResult.Text = e.Cancelled ? "Canceled" : e.Result.ToString();
            this.buttonCancel.Enabled = false;
            this.buttonCalculate.Enabled = true;
            this.progressBar1.Value = 100;
        }
    }
}
